#line 1 "D:/Projects/MikroC Projects/camera-click/CameraDriver.c"
#line 12 "D:/Projects/MikroC Projects/camera-click/CameraDriver.c"
char *Get_Camera_Data(unsigned long offset, unsigned long count, unsigned long *num);

sbit Ready_Pin at RE8_bit;
sbit Chip_Select at LATC2_bit;


const unsigned char __CMD_WRITE_REG = 2;
const unsigned char __CMD_READ_REG = 3;
const unsigned char __CMD_GET_FRAME = 4;
const unsigned char __CMD_GET_FRAME_BUFFERED = 5;
const unsigned char __CMD_SET_ROW_NUM = 6;
const unsigned char __CMD_SET_ROW_SIZE = 7;

unsigned char bmpHeader[10] = {0x00, 0x10,  144 ,  144 >>8,  176 ,  176 >>8, 0xFF, 0xFF, 0xFF, 0xFF};
unsigned char frmBuff[ 176 * 144 *2];
unsigned long bPos;


void SendCommand(unsigned char cmd) {
 while(Ready_Pin == 0)
 ;
 SPI_Read(cmd);
}


void ReadBytes(unsigned char *ptr, unsigned long num) {
 while(num){
 num--;
 while(Ready_Pin == 0)
 ;
 *ptr = SPI_Read(0);
 *ptr++;
 }
}


void SendBytes(unsigned char *ptr, unsigned long num) {
 while(num){
 num--;
 while(Ready_Pin == 0)
 ;
 SPI_Read(*ptr);
 *ptr++;
 }
}


unsigned char ReadReg(unsigned char regNum, unsigned char *regVal) {
 unsigned int status;

 SendCommand(__CMD_READ_REG);
 SendBytes(&regNum, 1);
 ReadBytes(&status, 2);
 *regVal = status & 0xFF;
 return status >> 8;
}


unsigned char WriteReg(unsigned char regNum, unsigned char regVal){
 unsigned int rv;
 unsigned char status;
 SendCommand(__CMD_WRITE_REG);
 rv = regNum | (regVal << 8);
 SendBytes(&rv, 2);
 ReadBytes(&status, 1);
 return status;
}


char* Get_Camera_Data(unsigned long offset, unsigned long count, unsigned long *num) {
 unsigned char* resPtr;

 *num = count;
 Chip_Select = 0;
 if(count == 10){
 *num = 10;
 bPos = 0;
 SendCommand(__CMD_GET_FRAME_BUFFERED);
 ReadBytes(frmBuff,  176 * 144 *2);
 return &bmpHeader[0];
 }
 Chip_Select = 1;
 resPtr = &frmBuff[bPos];
 bPos = bPos +  176 *2;
 return resPtr;
}
